#include "LoadMesh.h"
#include"w32init.h"
#include"main.h"


OBJ_FILE objModel;


LPDIRECT3DVERTEXBUFFER9 g_pVB = NULL; 

//////////////////////////////////////////
// Chargement de la mesh dans le buffer //
//////////////////////////////////////////
bool InitObjModel(char *File_name)
{

    CUSTOMVERTEX *pVertex;

	int i;

	objModel=Extract_Obj_File(objModel,File_name);

    if( FAILED( g_pDevice->CreateVertexBuffer( 3*objModel.Nb_face*sizeof(CUSTOMVERTEX),
                                                  D3DUSAGE_WRITEONLY, D3DFVF_CUSTOMVERTEX,
                                                  D3DPOOL_DEFAULT, &g_pVB, NULL ) ) )
    {
        return false;
    }


    if( FAILED( g_pVB->Lock( 0, 0, (void**)&pVertex, 0 ) ) )
        return false;


	for(i=0;i<3*objModel.Nb_face;i=i+3){
		pVertex->x=objModel.vertices[3*objModel.indices[i]];
		pVertex->y=objModel.vertices[3*objModel.indices[i]+1];
		pVertex->z=-objModel.vertices[3*objModel.indices[i]+2];
		pVertex->normal=D3DXVECTOR3(objModel.normals[i],objModel.normals[i+1],-objModel.normals[i+2]);
		pVertex->color=D3DCOLOR_XRGB(objModel.colors[i],objModel.colors[i+1],objModel.colors[i+2]);
		pVertex++;

		pVertex->x=objModel.vertices[3*objModel.indices[i+2]];
		pVertex->y=objModel.vertices[3*objModel.indices[i+2]+1];
		pVertex->z=-objModel.vertices[3*objModel.indices[i+2]+2];
		pVertex->normal=D3DXVECTOR3(objModel.normals[i],objModel.normals[i+1],-objModel.normals[i+2]);
		pVertex->color=D3DCOLOR_XRGB(objModel.colors[i],objModel.colors[i+1],objModel.colors[i+2]);
		pVertex++;

		pVertex->x=objModel.vertices[3*objModel.indices[i+1]];
		pVertex->y=objModel.vertices[3*objModel.indices[i+1]+1];
		pVertex->z=-objModel.vertices[3*objModel.indices[i+1]+2];
		pVertex->normal=D3DXVECTOR3(objModel.normals[i],objModel.normals[i+1],-objModel.normals[i+2]);
		pVertex->color=D3DCOLOR_XRGB(objModel.colors[i],objModel.colors[i+1],objModel.colors[i+2]);
		pVertex++;
	}

    g_pVB->Unlock();

    return true;

}


