//////SOURCE/////////////main.cpp//////////////////////////
///     Main                                		    ///
///     Version 10/2003      Par Grgory Smialek        ///
///////////www.texel.fr.fm//////texel@fr.fm////////////////

// Link:
// dxguid.lib d3d9.lib d3dx9.lib

#include <windows.h> 
#include <d3d9.h> 

#include "w32init.h"
#include "LoadMesh.h"
#include "main.h"
#include "d3ddisplay.h"

float rotateAngle=0.0f;

////////////////////////////////////////////////////////////
/////					WndProc							////
////////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc(HWND wpHWnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch(msg)
	{	
		case WM_DESTROY: 
		{ 
			PostQuitMessage(0);
			return 0;
		} break;

		default:break; 
	} 

	return DefWindowProc(wpHWnd, msg, wParam, lParam);
} 

////////////////////////////////////////////////////////////
/////					WinMain							////
////////////////////////////////////////////////////////////
int WINAPI WinMain(	HINSTANCE hInstance,HINSTANCE hPrevInstance, 
					LPSTR lpCmdLine,int nCmdShow) 
{
	
	MSG msg;
	BOOL	done=FALSE;
	
	// Cration du fentre Windows
	if(!CreateWin32Window(hInstance)) return 0;
	if (!g_hWnd)
		return 0; 

	// Initialisation de Direct3D
	if (Direct3DInit()==false)
	{
		MessageBox (NULL, TEXT ("Error while initializing Direct3D\nTry another Desktop Settings (colors)."),"ERROR", MB_ICONERROR);
		Direct3DRelease();
		return 0;
	}

	// Chargement du fichier .obj
	if (InitObjModel("BLENDER.obj")==false)
	{
		MessageBox (NULL, TEXT ("Error while initializing Vertex Buffer.\n"),"ERROR", MB_ICONERROR);
		Direct3DRelease();
		return 0;
	}


	// Boucle de message
	while(!done)
	{
		while (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{ 
		    TranslateMessage(&msg);
		    DispatchMessage(&msg); 

		    if (msg.message == WM_QUIT)
				done=TRUE;;
		}
				
		if (GetAsyncKeyState(VK_ESCAPE))
			PostQuitMessage(0);		

		if (GetAsyncKeyState(VK_LEFT))
			rotateAngle+=0.06f;

		if (GetAsyncKeyState(VK_RIGHT))
			rotateAngle-=0.06f;

		DrawScene();	
		
		
	} 

	// Libraation de Direct3D
	Direct3DRelease();


	return 0;
} 