//////SOURCE/////////////d3ddisplay.cpp////////////////////
///     d3ddisplay                               	    ///
///     Version 10/2003      Par Grgory Smialek        ///
///////////www.texel.fr.fm//////texel@fr.fm////////////////

#include"d3ddisplay.h"
#include "w32init.h"
#include "LoadMesh.h"
#include"main.h"

////////////////////////////////////////////////////
/////				SetupLight					////
////////////////////////////////////////////////////
void SetupLight(void)
{
	D3DXVECTOR3 vecDir;
	D3DLIGHT9 light;
	ZeroMemory( &light, sizeof(light) );
	light.Type = D3DLIGHT_DIRECTIONAL;

	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 1.0f;

	vecDir = D3DXVECTOR3(0.0f,0.0f,1.0f);
	D3DXVec3Normalize( (D3DXVECTOR3*)&light.Direction, &vecDir );

	light.Range = 1000.0f;
	g_pDevice->SetLight( 0, &light );
	g_pDevice->LightEnable( 0, TRUE);
	g_pDevice->SetRenderState( D3DRS_LIGHTING, TRUE );
}


////////////////////////////////////////////////////////////
/////					SetupMatrices					////
////////////////////////////////////////////////////////////
void SetupMatrices(void)
{
    D3DXMATRIXA16 matWorld;
	D3DXMatrixRotationY( &matWorld, rotateAngle );
    g_pDevice->SetTransform( D3DTS_WORLD, &matWorld );

    D3DXVECTOR3 vEyePt( 0.0f, 3.0f,-100.0f );
    D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
    D3DXMATRIXA16 matView;
    D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );
    g_pDevice->SetTransform( D3DTS_VIEW, &matView );

    D3DXMATRIXA16 matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 1000.0f );
    g_pDevice->SetTransform( D3DTS_PROJECTION, &matProj );	
}




////////////////////////////////////////////////////////////
/////					DrawScene						////
////////////////////////////////////////////////////////////
void DrawScene()
{

	SetupLight();

	g_pDevice->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(89,135,179), 1.0f, 0 );

	g_pDevice->BeginScene();

		SetupMatrices();
		
		g_pDevice->SetStreamSource( 0, g_pVB, 0, sizeof(CUSTOMVERTEX) );
        g_pDevice->SetFVF( D3DFVF_CUSTOMVERTEX );
        g_pDevice->DrawPrimitive( D3DPT_TRIANGLELIST, 0, objModel.Nb_face);

	g_pDevice->EndScene();
	g_pDevice->Present(NULL, NULL, NULL, NULL);
}