//////SOURCE/////////////w32init.cpp///////////////////////
///     w32init                                		    ///
///     Version 10/2003      Par Grgory Smialek        ///
///////////www.texel.fr.fm//////texel@fr.fm////////////////

#include"w32init.h"
#include"main.h"

const int WINDOW_WIDTH = 640; 
const int WINDOW_HEIGHT = 480; 
const int WINDOW_X = 0;  
const int WINDOW_Y = 0;  
const char *WINDOW_TITLE="VideoScape .obj file loading demo (www.texel.fr.fm)";
const char *WINDOW_CLASS_NAME="Texel Class"; // Class Name.

HINSTANCE g_hInst;	// Handle de l'instance du programme
HWND g_hWnd;		// Handle de la fentre principale

bool g_bFullscreen; // mode full screen

HRESULT g_hr; // Variable to hold function call results

IDirect3D9 *g_pDirect3D;	 // Pointer to Direct3D
IDirect3DDevice9 *g_pDevice; // Pointer to the Direct3D device

////////////////////////////////////////////////////////////
/////				CreateWin32Window					////
////////////////////////////////////////////////////////////
int CreateWin32Window(HINSTANCE hInstance)
{
	
	WNDCLASSEX winClass; 

	g_hInst=hInstance;

	winClass.cbSize         = sizeof(WNDCLASSEX); 
	winClass.style			= CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	winClass.lpfnWndProc	= WndProc; 
	winClass.cbClsExtra		= 0;
	winClass.cbWndExtra		= 0; 
	winClass.hInstance		= g_hInst; 
	winClass.hIcon			= LoadIcon(NULL, IDI_APPLICATION); 
	winClass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
	winClass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH); 
	winClass.lpszMenuName	= NULL; 
	winClass.lpszClassName	= WINDOW_CLASS_NAME; 
	winClass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

	if (!RegisterClassEx(&winClass)) 
		return 0;

	// Fullscreen ?
	if (MessageBox(NULL, "Would you like to run in fullscreen?", "Fullscreen?", MB_YESNO)==IDYES)
		g_bFullscreen=true;
	else 
		g_bFullscreen=false;

	if (g_bFullscreen==false)
	{
		g_hWnd = CreateWindowEx(WS_EX_CLIENTEDGE,  
							 WINDOW_CLASS_NAME,     
							 WINDOW_TITLE, 
							 WS_SYSMENU | WS_BORDER | WS_CAPTION | WS_VISIBLE, 
					 		 WINDOW_X, WINDOW_Y ,
							 WINDOW_WIDTH, WINDOW_HEIGHT,
							 NULL,
							 NULL,
							 g_hInst,  
							 NULL);	
	}
	else
	{
		g_hWnd = CreateWindowEx(NULL,  
							 WINDOW_CLASS_NAME,     
							 WINDOW_TITLE, 
							 WS_POPUP | WS_VISIBLE, 
					 		 WINDOW_X, WINDOW_Y ,
							 WINDOW_WIDTH, WINDOW_HEIGHT,
							 NULL,
							 NULL,
							 g_hInst,  
							 NULL);		
		

	}
	return 1;

}

////////////////////////////////////////////////////////////
/////			    	Direct3DInit					////
////////////////////////////////////////////////////////////
bool Direct3DInit() 
{
	g_pDirect3D=Direct3DCreate9(D3D_SDK_VERSION); 
	if (g_pDirect3D==NULL) 
		return false;

	D3DDISPLAYMODE displayMode; 
	if (g_bFullscreen==false) 
	{
		g_hr=g_pDirect3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &displayMode); 
		if (FAILED(g_hr)) 
			return false;
	}
	else
	{
		displayMode.Width=WINDOW_WIDTH;		
		displayMode.Height=WINDOW_HEIGHT;	
		displayMode.RefreshRate=0;			
		displayMode.Format=D3DFMT_R5G6B5;	
	}

	D3DPRESENT_PARAMETERS presentParameters; 
	memset(&presentParameters, 0, sizeof(D3DPRESENT_PARAMETERS)); 

	if (g_bFullscreen==false) 
	{ 
		presentParameters.Windowed   = TRUE; 
	}
	else 
	{
		presentParameters.Windowed   = FALSE; 
	}

	presentParameters.SwapEffect = D3DSWAPEFFECT_DISCARD;	 
	presentParameters.BackBufferFormat = displayMode.Format; 
	presentParameters.BackBufferWidth = displayMode.Width;   
	presentParameters.BackBufferHeight = displayMode.Height; 
	presentParameters.EnableAutoDepthStencil = TRUE;
    presentParameters.AutoDepthStencilFormat = D3DFMT_D16;

	
	g_hr=g_pDirect3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, g_hWnd,
                                  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                                  &presentParameters, &g_pDevice ); 
	if (FAILED(g_hr)) 
		return false;

	g_pDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_CCW);
    g_pDevice->SetRenderState( D3DRS_LIGHTING, FALSE );
	g_pDevice->SetRenderState( D3DRS_ZENABLE, TRUE );

	return true;
}

void Direct3DRelease()
{
	
	if( g_pVB != NULL )        
        g_pVB->Release();
	g_pVB=NULL;

	if (g_pDevice)
		g_pDevice->Release();
	g_pDevice=NULL;

	if (g_pDirect3D)
		g_pDirect3D->Release();
	g_pDirect3D=NULL;

}